/*  FSLView - 2D/3D Interactive Image Viewer

    James Saunders, David Flitney and Stephen Smith, FMRIB Image Analysis Group

    Copyright (C) 2002-2003 University of Oxford  */

/*  CCOPYRIGHT */

#include "glinfo.h"

class GLInfoTest : public QGLWidget
{
	public:

  GLInfoTest();
  virtual ~GLInfoTest();  

  QString m_vendor;
  QString m_renderer;
  QString m_version;
  QString m_extensions;
};

GLInfo::Handle GLInfo::create()
{
  Handle dst(new GLInfo());
  return dst;
}

GLInfo::GLInfo()
{ 
  GLInfoTest glTest;

  m_vendor     = glTest.m_vendor;
  m_renderer   = glTest.m_renderer;
  m_version    = glTest.m_version;
  m_extensions = glTest.m_extensions;
}

GLInfo::~GLInfo(){}

QString GLInfo::inqVendor(){return m_vendor;}
QString GLInfo::inqRenderer(){return m_renderer;}
QString GLInfo::inqVersion(){return m_version;}

bool GLInfo::imagingSubset()
{
  return queryExtension("GL_ARB_imaging");
}

bool GLInfo::limitToContexts()
{
  bool result(true);

  if(m_vendor.find("Nvidia",0,false)== -1)
    {result = false;}

  return result;
}

bool GLInfo::queryExtension(char *extName)
{
  if(m_extensions.find(extName) != -1)return true;

  return false;
}







GLInfoTest::GLInfoTest():QGLWidget()
{ 
  makeCurrent();
 
  char *ven = (char*) glGetString(GL_VENDOR);
  char *ren = (char*) glGetString(GL_RENDERER); 
  char *ver = (char*) glGetString(GL_VERSION); 
  char *ext = (char* )glGetString(GL_EXTENSIONS);

  m_vendor = ven;
  m_renderer = ren;
  m_version = ver;
  m_extensions = ext;
}

GLInfoTest::~GLInfoTest(){}




