/*  FSLView - 2D/3D Interactive Image Viewer

    James Saunders, David Flitney and Stephen Smith, FMRIB Image Analysis Group

    Copyright (C) 2002-2003 University of Oxford  */

/*  CCOPYRIGHT */

#if defined(WIN32) 
#pragma warning (disable:4786)
#endif

#include "application.h"
#include "splashscreen.h"

#include <qwindowsstyle.h>
#include <qapplication.h>
#include <qgl.h>

int main( int argc, char **argv )
{
  QApplication::setColorSpec( QApplication::CustomColor );
  QApplication a(argc,argv);			
  a.connect( &a, SIGNAL(lastWindowClosed()), &a, SLOT(quit()) );
  a.setStyle(new QWindowsStyle);

  if ( !QGLFormat::hasOpenGL() ) {
    qWarning( "This system has no OpenGL support. Exiting." );
    return -1;
  }

  SplashScreen *s = new SplashScreen(0);
  s->show();
  
  return a.exec();
}
