/*  FSLView - 2D/3D Interactive Image Viewer

    James Saunders, David Flitney and Stephen Smith, FMRIB Image Analysis Group

    Copyright (C) 2002-2003 University of Oxford  */

/*  CCOPYRIGHT */

#include "multserieswidget.h"
#include "qtabwidget.h"
#include "gridserieswidget.h"
#include "add.xpm"
#include <qtoolbar.h>
#include <qtoolbutton.h>

const char * addMultSeriesText = "Add series.<br><hr>Press to add the timeseries of the current cursor position.";

MultSeriesWidget::MultSeriesWidget(QWidget *parent,ImageGroup::Handle& i, Cursor::Handle& c):ViewWidget(parent), m_imageGroup(i),m_cursor(c)
{

  m_tabWidget = new QTabWidget(this);

  setCentralWidget(m_tabWidget);

  m_gridFront =  new GridSeriesWidget(this,m_imageGroup,false);  
  m_gridMiddle = new GridSeriesWidget(this,m_imageGroup,true);  
  m_gridBack =   new GridSeriesWidget(this,m_imageGroup,false);  


  m_tabWidget->addTab(m_gridFront,  "Front");  
  m_tabWidget->addTab(m_gridMiddle, "Middle");  
  m_tabWidget->addTab(m_gridBack,   "Behind");  

  m_tabWidget->showPage(m_gridMiddle);  

  QPixmap addIcon = QPixmap( add );

  QToolBar *tb1 = new QToolBar(this, "");  

  new QToolButton( addIcon, tr( addMultSeriesText ), QString::null,this, SLOT(addTimeSeries()), tb1, "Add time series" );

  addToolBar(tb1,Top,FALSE);
 

}
MultSeriesWidget::~MultSeriesWidget(){};

void MultSeriesWidget::setImageGroup(const ImageGroup::Handle& i)
{
  m_imageGroup = i;
}

void MultSeriesWidget::addTimeSeries()
{
  setTimeSeries();
}


void MultSeriesWidget::setTimeSeries()
{
  m_gridFront->setTimeSeries( m_cursor->inqX(),m_cursor->inqY(),m_cursor->inqZ() - 1);  
  m_gridMiddle->setTimeSeries(m_cursor->inqX(),m_cursor->inqY(),m_cursor->inqZ()    );
  m_gridBack->setTimeSeries(  m_cursor->inqX(),m_cursor->inqY(),m_cursor->inqZ() + 1);

}
