///////////////////////////////////////////////////////////////////////////
//
// @module morphology.h |
//
// This file declares functions for morphology operations.
//
// Copyright 2000 Yongyue Zhang (yongyue@fmrib.ox.ac.uk), All Rights Reserved
///////////////////////////////////////////////////////////////////////////

#ifndef __MORPHOLOGY__H_
#define __MORPHOLOGY__H_

#include <vector>
#include <algorithm>

#include "imagecore.h"
#include "zmath.h"

void CreateSquareKernel(std::vector< ZPoint<int> >& kernel, int width, int height, int depth=1);
void CreateRoundKernel(std::vector< ZPoint<int> >& kernel, int radius, bool b3D=false);
void Dilation(ZImageBase& image, const std::vector< ZPoint<int> >& kernel);
void Erosion(ZImageBase& image, const std::vector< ZPoint<int> >& kernel);
void Opening(ZImageBase& image, const std::vector< ZPoint<int> >& kernel);
void Closing(ZImageBase& image, const std::vector< ZPoint<int> >& kernel);

#endif
