/*  reform.cc - Subsample and merge utility
    
    Peter Bannister, FMRIB Image Analysis Group
    
    Copyright (C) 1999-2000 University of Oxford  */

/*  CCOPYRIGHT */


#include <math.h>
#include <iostream.h>
#include <fstream.h>
#include <stdlib.h>
#include <stdio.h>
#include <string>
#include <strstream>

#include "newimage/newimageall.h"
#include "newmatap.h"
#include "Globaloptions.h"

using namespace MISCMATHS;
using namespace NEWMAT;
using namespace NEWIMAGE;

int main (int argc,char** argv){
  
  volume4D<float> timeseries, lowres;
  volume<float> vout;
  volumeinfo vinfo;
  Matrix aff = Identity(4);
  int no_volumes;
  string inputfname;
  string inputbasename = "/usr/people/prb/medx/motion/synthetic/";

  vout.reinitialize(64, 64, 21);
  vout.setdims(4,4,6);


  inputfname = inputbasename + "null/start";
  cerr << "Reading time series " << inputfname << " ... " << endl;
  read_volume4D(timeseries,inputfname,vinfo);
  no_volumes = timeseries.tsize();

  lowres.reinitialize(timeseries);
  lowres.settdim(100);

  for (int i = 0; i < no_volumes; i++) {
    
    affine_transform(vout, timeseries[i], aff);
    lowres[i] = vout;
  }
  
  inputfname = inputbasename + "null/end";
  cerr << "Reading time series " << inputfname << " ... " << endl;
  read_volume4D(timeseries,inputfname,vinfo);
  no_volumes = timeseries.tsize();
  
  
  for (int i = 0; i < no_volumes; i++) {
    
    affine_transform(vout, timeseries[i], aff);
    lowres[i+no_volumes] = vout;
  }
  
  inputfname = inputbasename + "null/total";
  cerr << "Saving 0% activation time series to " + inputfname + " ... "<< endl;
  save_volume4D_dtype(lowres, inputfname, dtype(inputfname), vinfo);
  
  // now 2.5% level data
 //  inputfname = inputbasename + "0.025/start";
//   cerr << "Reading time series " << inputfname << " ... " << endl;
//   read_series(timeseries,inputfname,dtype);
//   no_volumes = timeseries.getSize();
 
//   for (int i = 0; i < no_volumes; i++) {
    
//     filled_affine_transform(vout, timeseries[i], aff);
//     lowres[i] = vout;
//   }
  
//   inputfname = inputbasename + "0.025/end";
//   cerr << "Reading time series " << inputfname << " ... " << endl;
//   read_series(timeseries,inputfname,dtype);
//   no_volumes = timeseries.getSize();
  
  
//   for (int i = 0; i < no_volumes; i++) {
    
//     filled_affine_transform(vout, timeseries[i], aff);
//     lowres[i+no_volumes] = vout;
//   }
  
//   inputfname = inputbasename + "0.025/total";
//   cerr << "Saving 2.5% activation time series to " + inputfname + " ... "<< endl;
//   save_series(lowres, inputfname, dtype);
  

}
