/*  nulldata.cc - copy EPI template 180 times
    add activation in Matlab
    use downsample.cc to resize
    
    Peter Bannister, FMRIB Image Analysis Group
    
    Copyright (C) 1999-2001 University of Oxford  */

/*  CCOPYRIGHT */


#include <math.h>
#include <iostream.h>
#include <fstream.h>
#include <iomanip>
#include <stdlib.h>
#include <stdio.h>
#include <string>
#include <strstream>

#include "newimage/newimageall.h"
#include "miscmaths/optimise.h"
#include "newimage/costfns.h"
#include "newmatap.h"

#include "Globaloptions.h"

using namespace MISCMATHS;
using namespace NEWMAT;
using namespace NEWIMAGE;

int main (int argc,char** argv){
  
  volume4D<float> timeseries;
  volume<float> mask;
  string outputfname;

  Matrix aff(4,4);
  aff = Identity(4);

  volumeinfo vinfo;
  read_volume(mask, "/usr/people/prb/medx/motion/neuroimage/templates/Cluster_aud", vinfo);
 
  volume<float> save(91,109,91);
  save. setdims(2,2,2);

  affine_transform(save, mask, aff);

  outputfname = string("Cluster_aud_hi");
  save_volume(save, outputfname, vinfo);
 
  read_volume(mask, "/usr/people/prb/medx/motion/neuroimage/templates/Cluster_vis", vinfo);
  affine_transform(save, mask, aff);
  outputfname = string("Cluster_vis_hi");
  save_volume(save, outputfname, vinfo);

}








