/* {{{ Copyright etc. */

/*  freqtest - produce test 4D data set with varying temporal frequencies

    Stephen Smith, FMRIB Image Analysis Group

    Copyright (C) 2000 University of Oxford  */

/*  CCOPYRIGHT */

/* }}} */
/* {{{ defines, includes and typedefs */

#include "libss/libss.h"
#include "libss/libavw.h"
#include <assert.h>

/* }}} */
/* {{{ main */

int main(int argc, char **argv)
{
  image_struct im;
  int x, t;

  if (argc<2)
    {
      printf("Usage: freqtest <outputfile>\n");
      exit(1);
    }

  im.x=200;
  im.y=1;
  im.z=1;
  im.t=200;

  im.xv=im.yv=im.zv=im.xv0=im.yv0=im.zv0=im.tr=1;
  im.xo=im.yo=im.zo=0;
  im.orient=0;

  im.dt=4;
  im.bpv=2;

  im.i=malloc(im.bpv*im.x*im.y*im.z*im.t);

  for(t=0;t<im.t;t++)
    for(x=0;x<im.x;x++)
      im.i[t*im.x+x]=10000 + 1000.0*cos( M_PI * t/(x+1.0) );

  avw_write(argv[1],im);

  return 0;
}

/* }}} */
