/* {{{ Copyright */

/*  runavw - works out what the data type is from argv[1] and then calls the
    correct program on the basis of argv[0] and the data type

    Stephen Smith, FMRIB Image Analysis Group

    Copyright (C) 1999-2002 University of Oxford  */

/*  CCOPYRIGHT */

/* }}} */
/* {{{ includes */

#include "libss/libss.h"
#include "libss/libavw.h"
#include <unistd.h>

/* }}} */
/* {{{ main */

int main(int argc, char *argv[])
{
  /* {{{ variables */

FILE *fd;
struct dsr hdr;
char thestring[10000], filename[10000], filename2[10000];
int i, datatype, bitpix;
static int DataTypeSizes[300] = {0, 1,8,0,16,0,0,0,32,0,0,0,0,0,0,0,32,
				    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,
				    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
				    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64 };

/* }}} */

  sprintf(thestring,"%s",argv[0]);
  if (thestring[0]!='/')
    sprintf(thestring,"%s/bin/%s",getenv("FSLDIR"),argv[0]);

  if (argc<2)
    {
      sprintf(thestring,"%s_16SI",thestring); /* assume 16SI to get usage */
      filename2[0]=0;
    }
  else
    {
      strcpy(filename2,argv[1]);
      if ( (strcmp(".hdr",filename2+strlen(filename2)-4)==0) ||
	   (strcmp(".img",filename2+strlen(filename2)-4)==0) )
	filename2[strlen(filename2)-4]=0;

      sprintf(filename,"%s.hdr",filename2);
      if((fd=fopen(filename,"rb"))==NULL)
	{
	  fprintf(stderr,"Can't open %s\n",filename);
	  exit(1);
	}
      fread(&hdr,1,sizeof(struct dsr),fd);

      if(hdr.hk.sizeof_hdr!=348)
	swap_hdr(&hdr);

      datatype=hdr.dime.datatype;
      bitpix=DataTypeSizes[datatype];
      sprintf(thestring,"%s_%d",thestring,bitpix);

      if (datatype==DT_UNSIGNED_CHAR) sprintf(thestring,"%sUI",thestring);
      if ((datatype==DT_SIGNED_SHORT)||(datatype==DT_SIGNED_INT)) sprintf(thestring,"%sSI",thestring);
      if ((datatype==DT_FLOAT)||(datatype==DT_DOUBLE)||(datatype==DT_COMPLEX)) sprintf(thestring,"%sR",thestring);
    }

  if((fd=fopen(thestring,"rb"))==NULL)
    {
      sprintf(filename,"%s.exe",thestring);
      if((fd=fopen(filename,"rb"))==NULL)
	{
	  fprintf(stderr,"This program has not been compiled for this data type\n");
	  exit(1);
	}
    }
  fclose(fd);

  sprintf(thestring,"%s %s",thestring,filename2);

  for(i=2; i<argc; i++)
    {
      sprintf(thestring,"%s %s",thestring,argv[i]);
    }

  return system(thestring);
}

/* }}} */
