#   fsl - meta-menu for fsl tools
#
#   Stephen Smith, FMRIB Image Analysis Group
#
#   Copyright (C) 1999-2003 University of Oxford
#
#   TCLCOPYRIGHT

#{{{ setups

source [ file dirname [ info script ] ]/fslstart.tcl

set VARS(history) {}

#}}}

proc fsl { w } {

    #{{{ vars and setup

global FSLDIR INMEDX argc argv PWD HOME gui_ext

set FSLVERSION [ exec sh -c "cat ${FSLDIR}/etc/fslversion" ]

toplevel $w -menu $w.f1.fmrib.menu
wm title $w "FSL $FSLVERSION"
wm iconname $w "FSL"
wm iconbitmap $w @${FSLDIR}/tcl/fmrib.xbm

set graphpic [image create photo -file ${FSLDIR}/doc/images/fsl-logo.gif ]

frame $w.f1

button $w.f1.label -image $graphpic -borderwidth 0 -relief raised -borderwidth 2 -command "FmribWebHelp file: ${FSLDIR}/doc/index.html"
pack $w.f1.label -in $w.f1

#}}}
    #{{{ main menu

if { [ file exists ${FSLDIR}/tcl/loadvarian.tcl ] } {
    button $w.f1.loadvarian -text "Load Varian" \
	    -command { exec sh -c "${FSLDIR}/bin/LoadVarian$gui_ext" & }
    pack $w.f1.loadvarian -in $w.f1 -fill x -padx 1 -pady 1
}

if { [ file exists ${FSLDIR}/tcl/bet.tcl ] } {
    button $w.f1.bet -text "BET Brain Extraction" \
	    -command { exec sh -c "${FSLDIR}/bin/Bet$gui_ext" & }
    pack $w.f1.bet -in $w.f1 -fill x -padx 1 -pady 1
}

if { [ file exists ${FSLDIR}/tcl/susan.tcl ] } {
    button $w.f1.susan -text "SUSAN Noise Reduction" \
	    -command { exec sh -c "${FSLDIR}/bin/Susan$gui_ext" & }
    pack $w.f1.susan -in $w.f1 -fill x -padx 1 -pady 1
}

if { [ file exists ${FSLDIR}/tcl/fast.tcl ] } {
    button $w.f1.fast -text "FAST Segmentation" \
	    -command { exec sh -c "${FSLDIR}/bin/Fast$gui_ext" & }
    pack $w.f1.fast -in $w.f1 -fill x -padx 1 -pady 1
}

if { [ file exists ${FSLDIR}/tcl/flirt.tcl ] } {
    button $w.f1.flirt -text "FLIRT Linear Registration" \
	    -command { exec sh -c "${FSLDIR}/bin/Flirt$gui_ext" & }
    pack $w.f1.flirt -in $w.f1 -fill x -padx 1 -pady 1
}

if { [ file exists ${FSLDIR}/tcl/feat.tcl ] } {
    button $w.f1.feat -text "FEAT FMRI Analysis" \
	    -command { exec sh -c "${FSLDIR}/bin/Feat$gui_ext" & }
    pack $w.f1.feat -in $w.f1 -fill x -padx 1 -pady 1
}

if { [ file exists ${FSLDIR}/tcl/melodic.tcl ] } {
    button $w.f1.melodic -text "MELODIC ICA" \
	    -command { exec sh -c "${FSLDIR}/bin/Melodic$gui_ext" & }
    pack $w.f1.melodic -in $w.f1 -fill x -padx 1 -pady 1
}

if { [ file exists ${FSLDIR}/bin/fslview ] || [ file exists ${FSLDIR}/bin/fslview.exe ] } {
    button $w.f1.fslview -text "FSLView" \
	    -command { exec sh -c "${FSLDIR}/bin/fslview" & }
    pack $w.f1.fslview -in $w.f1 -fill x -padx 1 -pady 1
}

#}}}
    #{{{ Button Frame

    frame $w.btns
 
    button $w.cancel -command "destroy $w" -text "Exit"
 
    button $w.help -command "FmribWebHelp file: ${FSLDIR}/doc/index.html" -text "Help"

    pack $w.cancel $w.help -in $w.btns -side left -anchor s -expand yes -padx 2 -pady 2 -fill x
 
    pack $w.f1 $w.btns -expand yes -fill x

#}}}
}

wm withdraw .
fsl .rename
tkwait window .rename
