
set USER     $env(USER)
set HOME     [ exec sh -c " cd ; pwd " ]
set PWD      [ exec sh -c " pwd " ]
set PROCID   [ pid ]
set HOSTNAME [ exec hostname ]
set OS       [ exec uname ]

# are we running inside MEDx?
if { ! [ info exists INMEDX ] } {

    set INMEDX 1
    set PXHOME $env(PXHOME)

    # kludge to tell whether we are in version 3.2 or 3.3
    # (here 3.3 means 3.3 or higher)
    if { [ file exists ${PXHOME}/ui/dialogs/talairachdaemon.tcl ] } {
	set MEDXV 3.3
    } else {
	set MEDXV 3.2
    }

    set auto_path [ linsert $auto_path 0 $PXHOME/ui $PXHOME/ui/tix ]
    set bitmapdir $PXHOME/ui/bitmaps
    set Message(freeze) ""

} else {

    # make sure that we aren't using any MEDx stuff
    set PXHOME /grotgrot
    
}

# set FSLDIR from environment, or, failing that, PXHOME
if { [ info exists env(FSLDIR) ] } {
    set FSLDIR $env(FSLDIR)
} else {
    set FSLDIR $PXHOME/fsl
    set env(FSLDIR) $FSLDIR
}
set auto_path [ linsert $auto_path 0 $FSLDIR/tcl ]

# for running outside of FMRIB don't try to renice
if { [ file exists /usr/local/bin/nicemedx ] } {
    set RENICE 1
} else {
    set RENICE 0
}

# are we on the FMRIB cluster?
set CLUSTERRSH ""
if { $HOSTNAME == "cayenne.fmrib.ox.ac.uk" } {
    catch { exec sh -c "cat /usr/local/etc/whichcrunch/whichcrunch.id" } WHICHCRUNCH
    if { $WHICHCRUNCH == "crunch0" || $WHICHCRUNCH == "crunch1" } {
	set CLUSTERRSH "rsh -n $WHICHCRUNCH"
    }
}

if { ! [ info exists INGUI ] } {
    source $FSLDIR/tcl/FSLFileDirBox.tcl
    source $FSLDIR/tcl/FSLFileDirDlg.tcl
    source $FSLDIR/tcl/FSLFileEntry.tcl
}

# what type of OS?
set OSFLAVOUR unix
set gui_ext ""
set FSLSLASH ""
set UNAME [ exec uname ]
if { $UNAME == "Darwin" } {
    set OSFLAVOUR macos
    set gui_ext "_gui"
} elseif { [ string compare CYGWIN [ string range $UNAME 0 5 ] ] == 0 } {
    set OSFLAVOUR cygwin
    set gui_ext "_gui"
    set FSLSLASH "C:/cygwin"
}

