#

#   mask - convert image to MINC and run Display and the reread image
#
#   Stephen Smith, FMRIB Image Analysis Group
#
#   Copyright (C) 1999-2000 University of Oxford
#
#   TCLCOPYRIGHT

if { [ info exists env(FSLDIR) ] } {
    set FSLDIR $env(FSLDIR)
} else {
    set FSLDIR $PXHOME/fsl
}

source ${FSLDIR}/tcl/medxstart.tcl
set auto_path [ linsert $auto_path 0 [ file dirname [ info script ] ] ]

proc mni_mask {Folder In TheArgs} {
    global PXHOME USER PROCID exceed

# save image to temp AVW file
FSLSaveAs $In AVW /tmp/${USER}_${PROCID}_mask.hdr true

# convert to minc
set thecommand "exec /usr/local/mni/bin/analyze2minc /tmp/${USER}_${PROCID}_mask"
ScriptUpdate "Converting to MINC format: $thecommand"
set result [catch {eval $thecommand} ErrMsg]

# run external program
set thecommand "exec xterm -e /usr/local/mni/bin/Display /tmp/${USER}_${PROCID}_mask.mnc &"
set result [catch {eval $thecommand} ErrMsg]

after 5000
after 5000
MxPause "Now create a coloured mask in the \"Display\" program from Montreal. DO NOT CHANGE THE DEFAULT LABEL COLOUR/VALUE! Use right-mouse to draw mask points and shift-right-mouse to delete mask points. Use left- and middle-mouse to move around in the image. To change the mask drawing cursor size click (in the menu window) \"Segmenting\", then \"XY Radius\", and enter the value in the XTerm, and finally press \"Pop Menu\". When you are finished, save the mask to file using (in the menu window) \"File\", then \"Save Labels .mnc\" and enter the following filename in the XTerm and press return: /tmp/${PROCID}.mnc then you can exit \"Display\"\n\nWhen you are finished press OK"

# convert to minc
set thecommand "exec /usr/local/mni/bin/mincresample /tmp/${PROCID}.mnc /tmp/${USER}_${PROCID}_label.mnc -like /tmp/${USER}_${PROCID}_mask.mnc"
ScriptUpdate "Converting to AVW format 1/2: $thecommand"
set result [catch {eval $thecommand} ErrMsg]
set thecommand "exec /usr/local/mni/bin/minc2analyze /tmp/${USER}_${PROCID}_label"
ScriptUpdate "Converting to AVW format 2/2: $thecommand"
set result [catch {eval $thecommand} ErrMsg]

MxOpenImage $Folder /tmp/${USER}_${PROCID}_label.hdr I1
MxSetCurrentPage $I1

}
