#

#   register - view registration of two images
#
#   Stephen Smith, FMRIB Image Analysis Group
#
#   Copyright (C) 1999-2000 University of Oxford
#
#   TCLCOPYRIGHT

if { [ info exists env(FSLDIR) ] } {
    set FSLDIR $env(FSLDIR)
} else {
    set FSLDIR $PXHOME/fsl
}

source ${FSLDIR}/tcl/medxstart.tcl
set auto_path [ linsert $auto_path 0 [ file dirname [ info script ] ] ]

proc mni_register {Folder Group TheArgs} {
    global PXHOME USER PROCID exceed

# find input images
MxGetPagesFromGroup $Group Pages
set Image1 [ lindex $Pages 0 ]
set Image2 [ lindex $Pages 1 ]

# save image to temp AVW file
ScriptUpdate "Saving temporary files"
FSLSaveAs $Image1 AVW /tmp/${USER}_${PROCID}_image1.hdr true
FSLSaveAs $Image2 AVW /tmp/${USER}_${PROCID}_image2.hdr true

# convert to minc
set thecommand " exec /usr/local/mni/bin/analyze2minc /tmp/${USER}_${PROCID}_image1 "
ScriptUpdate "Converting to MINC format: $thecommand"
set result [catch {eval $thecommand} ErrMsg]
set thecommand " exec /usr/local/mni/bin/analyze2minc /tmp/${USER}_${PROCID}_image2 "
ScriptUpdate "Converting to MINC format: $thecommand"
set result [catch {eval $thecommand} ErrMsg]
CancelScriptUpdate

# run external program
set thecommand "exec xterm -e /usr/local/mni/bin/register /tmp/${USER}_${PROCID}_image1.mnc /tmp/${USER}_${PROCID}_image2.mnc &"
set result [catch {eval $thecommand} ErrMsg]

after 1800000

set errrr [catch {exec /bin/rm -f /tmp/${USER}_${PROCID}_image1.mnc /tmp/${USER}_${PROCID}_image1.img /tmp/${USER}_${PROCID}_image1.hdr /tmp/${USER}_${PROCID}_image2.mnc /tmp/${USER}_${PROCID}_image2.img /tmp/${USER}_${PROCID}_image2.hdr } junk]
set errrr [catch {exec /bin/rm -f /tmp/${USER}_${PROCID}_image1.mnc /tmp/${USER}_${PROCID}_image1.img /tmp/${USER}_${PROCID}_image1.hdr /tmp/${USER}_${PROCID}_image2.mnc /tmp/${USER}_${PROCID}_image2.img /tmp/${USER}_${PROCID}_image2.hdr } junk]
set errrr [catch {exec /bin/rm -f /tmp/${USER}_${PROCID}_image1.mnc /tmp/${USER}_${PROCID}_image1.img /tmp/${USER}_${PROCID}_image1.hdr /tmp/${USER}_${PROCID}_image2.mnc /tmp/${USER}_${PROCID}_image2.img /tmp/${USER}_${PROCID}_image2.hdr } junk]

}
