#

#   rolling_display - rolling display of pages in a group
#
#   Stephen Smith, FMRIB Image Analysis Group
#
#   Copyright (C) 1999-2000 University of Oxford
#
#   TCLCOPYRIGHT

if { [ info exists env(FSLDIR) ] } {
    set FSLDIR $env(FSLDIR)
} else {
    set FSLDIR $PXHOME/fsl
}

source ${FSLDIR}/tcl/medxstart.tcl
set auto_path [ linsert $auto_path 0 [ file dirname [ info script ] ] ]

MxGetCurrentFolder Folder
MxGetCurrentGroup Group
MxGetPagesFromGroup $Group Pages

set delay 10
set repetitions 20000
InputFromWidget "Rolling Display Control" 2 "Delay between pages (seconds)" delay 10 "Number of repetitions" repetitions 10
set delay [ expr $delay * 1000 ]

set count 0
while {$count < $repetitions} {
    foreach Page $Pages {
	MxSetCurrentPage $Page
	after $delay
    }
    incr count 1
}
