#

#   what_type - find out the current page type
#
#   Stephen Smith, FMRIB Image Analysis Group
#
#   Copyright (C) 1999-2000 University of Oxford
#
#   TCLCOPYRIGHT

# returns:
# 0 = no folder
# 1 = no page (possibly not possible)
# 2 = 2D image page
# 3 = 3D volume page
# 4 = 4D group page

proc what_type { popups } {

    set error [ MxGetCurrentFolder Folder ]
    if { $error == 1 } {
	puts "You don't have an open folder!"
	if { $popups } {
	    MxPause "You don't have an open folder!"
	}
	return 0

    } else {
	set error [ MxGetCurrentPage Page ]
	if { $error != 0 } {
	    puts "You don't have an open page!"
	    if { $popups } {
		MxPause "You don't have an open page!"
	    }
	    return 1

	} else {
	    MxGetPageProperties $Page Props
	    set PageType [ keylget Props Type ]
	    if { [ string match $PageType Group ] == 1 } {
		return 4

	    } else {
		if { [ string match $PageType Volume ] == 1 } {
		    return 3

		} else {
		    if { [ string match $PageType Image ] == 1 } {
			return 2

		    } else {
			puts "You don't have an open page!"
			if { $popups } {
			    MxPause "You don't have an open page!"
			}
			return 1

		    }
		}
	    }
	}
    }

}

