// General call feature for templated image classes
//  Written by Mark Jenkinson  March 2000

#if !defined(__fmribmain_h)
#define __fmribmain_h

#include <iostream>
#include "avwio/avwio.h"

using namespace std;

template <class T>
int fmrib_main(int argc, char* argv[]);


int call_fmrib_main(short datatype, int argc, char* argv[])
{
  switch (datatype) {
  case DT_UNSIGNED_CHAR:
    return fmrib_main<char>(argc, argv);
  case DT_SIGNED_SHORT:
    return fmrib_main<short>(argc, argv);
  case DT_SIGNED_INT:
    return fmrib_main<int>(argc, argv);
  case DT_FLOAT:
    return fmrib_main<float>(argc, argv);
  case DT_DOUBLE:
    return fmrib_main<double>(argc, argv);
  case DT_COMPLEX:
    cerr << "COMPLEX not supported as an independent type" << endl;
    return -1;
  default:
    cerr << "Datatype " << datatype << " is NOT supported - please check your image" << endl;
    return -1;
  }
}

#endif
