#

#   current_group - see if a folder is open, then tests to see if a group is on view in the current folder
#
#   Stephen Smith, FMRIB Image Analysis Group
#
#   Copyright (C) 1999-2000 University of Oxford
#
#   TCLCOPYRIGHT

proc current_group { popups } {

    set error [MxGetCurrentFolder Folder]
    if {$error == 1} {

	puts "You don't have an open folder!"
	if { $popups } {
	    MxPause "You don't have an open folder!"
	}

	return 0

    } else {

	set error [MxGetCurrentPage Page]
	if {$error != 0} {

	    puts "You aren't viewing a group in the current folder!"
	    if { $popups } {
		MxPause "You aren't viewing a group in the current folder!"
	    }

	    return 0

	} else {

	    MxGetPageProperties $Page Props
	    set PageType [keylget Props Type]
	    if {[string match $PageType Group] != 1} {

		puts "You aren't viewing a group in the current folder!"
		if { $popups } {
		    MxPause "You aren't viewing a group in the current folder!"
		}

	    return 0

	    } else {

	    return 1

	    }
	}
    }
}
