#

# cut_corner
#
#   Stephen Smith, FMRIB Image Analysis Group
#
#   Copyright (C) 1999-2000 University of Oxford
#
#   TCLCOPYRIGHT

# this prompts for a 2D rectangle and then deletes inside this and all
# corresponding places in all higher slices

if { [ info exists env(FSLDIR) ] } {
    set FSLDIR $env(FSLDIR)
} else {
    set FSLDIR $PXHOME/fsl
}

source ${FSLDIR}/tcl/medxstart.tcl
set auto_path [ linsert $auto_path 0 [ file dirname [ info script ] ] ]

proc cut_corner {Folder Volume Popups} {

# find number of slices for use at end
MxGetImageProperties $Volume VolProps
set VolZ [keylget VolProps Slices]

# set graphics mode to 2D and prompt user to draw rectangle
MxSetLightboxView $Volume
MxSetImageOpMode $Volume 2D1
MxSetGraphicToolMode Rectangle
MxPause "Please draw a rectangle"

# grab rectangle and get its properties
MxGetCurrentGraphic G0
MxSetImageOpMode $Volume 3D
MxGetRectangleProperties $G0 Properties
set x [keylget Properties X]
set y [keylget Properties Y]
set width [keylget Properties Width]
set height [keylget Properties Height]
set z [keylget Properties Z]
set depth [expr $VolZ - $z]

# find image value to set inside rectangle
MxGetDisplayRange $Volume V themin themax

# draw 3D box derived from 2D rectangle and delete inside
MxDrawBox $Volume $x $y $z $width $height $depth G1
MxExpr "{EvalROI $G1}" $Volume = " $themin "

# remove graphics
MxDeleteGraphic { $G0 }
MxDeleteGraphic { $G1 }

# reset display range
MxSetDisplayRange $Volume V $themin $themax

}
