#

#{{{ setup

#   median - GUI for group median
#
#   Stephen Smith, FMRIB Image Analysis Group
#
#   Copyright (C) 1999-2000 University of Oxford
#
#   TCLCOPYRIGHT

if { [ info exists env(FSLDIR) ] } {
    set FSLDIR $env(FSLDIR)
} else {
    set FSLDIR $PXHOME/fsl
}

source ${FSLDIR}/tcl/medxstart.tcl
set auto_path [ linsert $auto_path 0 [ file dirname [ info script ] ] ]

#}}}

proc group_median {Folder Group Popups} {

    global USER FSLDIR

    #{{{ run the median program

MxGetPageProperties $Group GroupProps
set GroupName [keylget GroupProps Name]

set TN [ exec sh -c "${FSLDIR}/bin/tmpnam /tmp/med" ]

FSLSaveAs $Group AVW ${TN}.hdr true

set thecommand "${FSLDIR}/bin/median $TN ${TN}_out"

puts $thecommand
if {$Popups == 1} {
  ScriptUpdate "Calling $thecommand"
}
catch { sh -c $thecommand } result

if {$result != 0} {
  puts "$ErrMsg"
}

if {$Popups == 1} {
  CancelScriptUpdate
}

#}}}
    #{{{ read in the output

MxOpenImage $Folder ${TN}_out.hdr Output

MxComputeDisplayRange $Output V Min Max

MxGetImageProperties $Output pl
keylset pl Name "Median of $GroupName"
MxSetImageProperties $Output $pl

exec sh -c "rm -f ${TN}*"

#}}}

    return $Output
}
