proc SelectPage:Dialog { w index min max filelist} {
    global selectpage
    global SelectPageIndex

    set SelectPageIndex $index

    if [winfo exists $w.sp] {
        wm deiconify $w.sp
        raise $w.sp
        return
    }
   
    toplevel $w.sp
    wm title $w.sp "FSL Select Page"
    wm iconname $w.sp "FSL Select Page"
	    
    #------------- Do the Main Side ----------------

    frame $w.sp.lf

    #------------- Upper Frame --------------

    frame $w.sp.lf.uf

    label $w.sp.lf.uf.l1 -text "Type of Pages" -anchor nw
    label $w.sp.lf.uf.l2 -text "List of Pages" -anchor nw

    #------------- Middle Frame --------------

    frame $w.sp.lf.mf

    frame $w.sp.lf.mf.lf
    frame $w.sp.lf.mf.rf

    SelectPage:pagetypebutton $w images Images Image
    SelectPage:pagetypebutton $w volumes Volumes Volume
    SelectPage:pagetypebutton $w groups Groups Group
    SelectPage:pagetypebutton $w browsable All All

    tixScrolledListBox $w.sp.pagelist -scrollbar both \
	-width 260 -height 300
    $w.sp.pagelist subwidget listbox configure -selectmode extended

    #------------- Bottom Frame --------------

    # ---- Status Bar ----

    label $w.sp.lf.status -height 1 -relief sunken -bd 2 


    #------------- Button Frame --------------

    frame $w.sp.lf.btns
    frame $w.sp.lf.btns.b -relief raised -borderwidth 1
    button $w.sp.ok -text "OK" -width 6 \
	    -command "SelectPage:Apply $w destroy $min $max $filelist"

    button $w.sp.apply -text "Apply" -width 6 \
	-command "SelectPage:Apply $w keep $min $max $filelist"

    button $w.sp.cancel -command "SelectPage:Destroy $w" \
	-text "Cancel" -width 6

    #------------- Pack --------------

    pack $w.sp.lf -side left -anchor n -expand yes -fill both

    pack $w.sp.lf.uf $w.sp.lf.mf -padx 3 -pady 0 \
	    -expand yes -fill both
    pack $w.sp.lf.status $w.sp.lf.btns -padx 3 -pady 10 \
	    -expand yes -fill both

    #------------- Pack Upper Frame --------------

    pack $w.sp.lf.uf.l1 $w.sp.lf.uf.l2 -side left -expand yes -fill both

    #------------- Pack Middle Frame --------------

    pack $w.sp.lf.mf.lf \
	-side left -padx 3 -fill both
    pack $w.sp.lf.mf.rf \
	-side left -padx 3 -expand yes -fill both

    pack $w.sp.pagelist -in $w.sp.lf.mf.rf \
	-side top -expand yes -fill both -padx 3 -pady 5

    #------------- Pack Button Frame --------------

    pack $w.sp.lf.btns.b -fill x -padx 5 -pady 10 
    pack $w.sp.ok $w.sp.apply $w.sp.cancel -in $w.sp.lf.btns.b \
	-side left -expand yes -padx 5 -pady 10 -fill y

    SelectPage:SetDefaults $w
}

proc SelectSinglePage:Dialog { w file { callback {} }} {
    global selectpage

    if [winfo exists $w.sp] {
        wm deiconify $w.sp
        raise $w.sp
        return
    }
   
    toplevel $w.sp
    wm title $w.sp "FSL Select Page"
    wm iconname $w.sp "FSL Select Page"
	    
    #------------- Do the Main Side ----------------

    frame $w.sp.lf

    #------------- Upper Frame --------------

    frame $w.sp.lf.uf

    label $w.sp.lf.uf.l1 -text "Type of Pages" -anchor nw
    label $w.sp.lf.uf.l2 -text "List of Pages" -anchor nw

    #------------- Middle Frame --------------

    frame $w.sp.lf.mf

    frame $w.sp.lf.mf.lf
    frame $w.sp.lf.mf.rf

    SelectPage:pagetypebutton $w images Images Image
    SelectPage:pagetypebutton $w volumes Volumes Volume
    SelectPage:pagetypebutton $w groups Groups Group
    SelectPage:pagetypebutton $w browsable All All

    tixScrolledListBox $w.sp.pagelist -scrollbar both \
	-width 260 -height 300
    $w.sp.pagelist subwidget listbox configure -selectmode extended

    #------------- Bottom Frame --------------

    # ---- Status Bar ----

    label $w.sp.lf.status -height 1 -relief sunken -bd 2 


    #------------- Button Frame --------------

    frame $w.sp.lf.btns
    frame $w.sp.lf.btns.b -relief raised -borderwidth 1
    button $w.sp.ok -text "OK" -width 6 \
	    -command "SelectPage:ApplySingle $w destroy $file \"$callback\""

    button $w.sp.apply -text "Apply" -width 6 \
	-command "SelectPage:ApplySingle $w keep $file \"$callback\""

    button $w.sp.cancel -command "SelectPage:Destroy $w" \
	-text "Cancel" -width 6

    #------------- Pack --------------

    pack $w.sp.lf -side left -anchor n -expand yes -fill both

    pack $w.sp.lf.uf $w.sp.lf.mf -padx 3 -pady 0 \
	    -expand yes -fill both
    pack $w.sp.lf.status $w.sp.lf.btns -padx 3 -pady 10 \
	    -expand yes -fill both

    #------------- Pack Upper Frame --------------

    pack $w.sp.lf.uf.l1 $w.sp.lf.uf.l2 -side left -expand yes -fill both

    #------------- Pack Middle Frame --------------

    pack $w.sp.lf.mf.lf \
	-side left -padx 3 -fill both
    pack $w.sp.lf.mf.rf \
	-side left -padx 3 -expand yes -fill both

    pack $w.sp.pagelist -in $w.sp.lf.mf.rf \
	-side top -expand yes -fill both -padx 3 -pady 5

    #------------- Pack Button Frame --------------

    pack $w.sp.lf.btns.b -fill x -padx 5 -pady 10 
    pack $w.sp.ok $w.sp.apply $w.sp.cancel -in $w.sp.lf.btns.b \
	-side left -expand yes -padx 5 -pady 10 -fill y

    SelectPage:SetDefaults $w
}

proc SelectPage:ListUpdate { w } {

    global selectpage

    $w.sp.pagelist subwidget listbox delete 0 end
    if {[MxGetCurrentFolder Folder]} {
	SelectPage:Destroy $w
	MxPause "No folder open!"
	return
    }
    MxGetPagesFromFolder $Folder Pages
    foreach element $Pages {
	MxGetPageProperties $element List
	if {$selectpage(pagetype)=="All"} {
	    set name [keylget List Name]
	    $w.sp.pagelist subwidget listbox insert end "$name"
	} else {
	    set type [keylget List Type]
	    if {$type==$selectpage(pagetype)} {
		set name [keylget List Name]
		$w.sp.pagelist subwidget listbox insert end "$name"
	    }
	}
    }

}
proc SelectPage:SetDefaults {w} {
    global selectpage
    
    set selectpage(pagetype) All
    SelectPage:ListUpdate $w
}
proc SelectPage:Apply {w dialog min max filelist} {

    upvar $filelist FileList
    global SelectPageIndex

    set list [GetListSelections [$w.sp.pagelist subwidget listbox]]
    
    set l [llength $list] 
    if {$l == 0} {
	ShowMessage "Nothing selected." false
	return 0
    } elseif {$l >1} {
	ShowMessage "Please select only one item." false
	return 0
    }
    
    set FileList($w,$SelectPageIndex) [lindex $list 0]

    incr SelectPageIndex

    if {$SelectPageIndex>$max} {
	set SelectPageIndex $min
    }

    if {$dialog == "destroy"} {
	   SelectPage:Destroy $w
    }
}
proc SelectPage:ApplySingle {w dialog file {callback {}}} {

    upvar $file File
    global SelectPageIndex

    set list [GetListSelections [$w.sp.pagelist subwidget listbox]]
    
    set l [llength $list] 
    if {$l == 0} {
	ShowMessage "Nothing selected." false
	return 0
    } elseif {$l >1} {
	ShowMessage "Please select only one item." false
	return 0
    }
    
    set File [lindex $list 0]

    if {$dialog == "destroy"} {
	   SelectPage:Destroy $w
    }

    if {$callback != ""} {
	uplevel $callback
    }
}
proc SelectPage:Destroy {w} {
    global selectpage
    destroy $w.sp
}

proc SelectPage:pagetypebutton { w sub label array } {
    global selectpage

    radiobutton $w.sp.$sub -text $label \
	    -variable selectpage(pagetype) \
	    -value $array \
	    -command "SelectPage:ListUpdate $w" \
	    -anchor nw
    pack $w.sp.$sub -in $w.sp.lf.mf.lf -side top -fill both -expand yes -padx 3 -pady 5
}

